#! /usr/bin/perl

use POSIX ":sys_wait_h";

($progname = $0) =~ s(.*/)();
$filler = ' ' x (length $progname);

sub mydate();
sub mailto($@);
sub newout ($);
sub endout (@);
sub read_dbsource ($);
sub update_dbfiles ($$\@\%&);
sub cmp_mt ($$);
sub cmp_rt ($$);
sub cmp_ac ($$);

$ToAdmin = 'named@isv-gmbh.de';
#$ToAdmin = 'bj@isv-gmbh.de';
$VxWorkdir = "/var/spool/VxMail";
#$VxWorkdir = "/home/bj/src/Perl/VxMail-Kunden";
@vxopts = ();
$mailcmd = '/usr/lib/sendmail -t';
$mkdb = '/usr/sbin/vxmkdb';
#$mkdb = '/usr/local/sbin/vxmkdb';
$dump = '/usr/sbin/vxdump';
#$dump = '/usr/local/sbin/vxdump';
$getconf = '/usr/sbin/vxgetconf';
#$getconf = '/usr/local/sbin/vxgetconf';

#X#
$BaseDB = "$VxWorkdir/userdb.system";
$Import = "$VxWorkdir/userdb.secure";
$Backup = sprintf "%s/userdb-%04d%02d%02d.dmp", $VxWorkdir, mydate();

# Der erste Schritt besteht im Auslesen der verschiedenen Datenbankquell-
# dateien, die unter `/etc/mail' stehen und mit bercksichtigt werden mssen.
($mthead, $mtbindings) = read_dbsource ('/etc/mail/mailertable');
unless (defined $mthead) { die "$progname: `/etc/mailertable' is required!\n"; }

($rthead, $rtbindings) = read_dbsource ('/etc/mail/RelayTo');
($achead, $acbindings) = read_dbsource ('/etc/mail/access');


# Als nchstes mu die alte Datenbank gerettet werden; dies geschieht mittels
# eines Aufrufs von `vxdump'.
#
@dumps = sort { $a cmp $b } glob "$VxWorkdir/userdb-*.dmp";
if (@dumps > 7) { unlink (shift @dumps); }
if (system "$dump", @vxopts, "-o$Backup") {
    mailto $ToAdmin,
	"WARNUNG: Rettung des alten Datenbankinhalts fehlgeschlagen!\n";
}

# Als nchstes wird die Basisdatenbank erzeugt. Dazu ffne ich die $BaseDB
# jedoch in dem Perl-Skript, da ich mir die Domains merken mu (mchte).

newout ("/tmp/$progname-dirs.$$");
unless (open TODB, "|$mkdb -d1 " . join(' ', @vxopts)) {
    endout ("/tmp/$progname-dirs.$$");
    mailto $ToAdmin,
	"WARNUNG: Neuerzeugung der Mail-DB fehlgeschlagen:\n ==> `$!'\n";
    die "$progname: Failed to create the MailDB: $!\n";
}

unless (open BASE, "<$BaseDB") {
    endout ("/tmp/$progname-dirs.$$");
    close TODB;
    print STDERR "$progname: Failed to create the MailDB: $!\n";
    if (system $mkdb, @vxopts, '-d1', $Backup) {
	mailto $ToAdmin,
	    "FATALER FEHLER: Restaurierung der ursprnglichen Mail-DB\n",
	    "nach einer fehlgeschlagenen Neuerzeugung ist ebenfalls\n",
	    "fehlgeschlagen!\n";
	die "$progname: FATAL! I couldn't restore the original MailDB!\n";
    } else {
	mailto $ToAdmin,
	    "WARNUNG: Neuerzeugung der Mail-DB ist fehlgeschlagen.\n",
	    "Die ursprngliche Mail-DB konnte wiederhergestellt werden.\n";
	die "$progname: original MailDB restored!\n";
    }
}

%domains = ();
while (<BASE>) {
    print TODB $_;
    chomp;
    if (m(^NONSTD\s+DOMAIN\s+\"([^\"]+)\")) {
#print STDERR "**** Inserting NONSTD domain `$1' ($_).\n";
	$domains{$1} = $_ unless (exists $domains{$1});
    } elsif (m(^DOMAIN\s+\"([^\"]+)\")) {
#print STDERR "**** Inserting domain `$1' ($_).\n";
	$domains{$1} = $_ unless (exists $domains{$1});
    }
}
close BASE;
close TODB;

unless (open TODB, "|$mkdb -d1 " . join(' ', @vxopts)) {
    endout ("/tmp/$progname-dirs.$$");
    print STDERR "$progname: Failed to open users database: $!\n";
    if (system $mkdb, @vxopts, '-d1', $Backup) {
	mailto $ToAdmin,
	    "FATALER FEHLER: Restaurierung der ursprnglichen Mail-DB\n",
	    "nach einer fehlgeschlagenen Eintragung der extern verwalteten\n",
	    "ist ebenfalls fehlgeschlagen!\n";
	die "$progname: FATAL! I couldn't restore the original MailDB!\n";
    } else {
	mailto $ToAdmin,
	    "WARNUNG: Eintragung der extern verwalteten Kunden in die\n",
	    "Mail-DB ist fehlgeschlagen. Die ursprngliche Mail-DB konnte\n",
	    "wiederhergestellt werden.\n";
	die "$progname: original MailDB restored!\n";
    }
}

# Der nchste Schritt besteht im Einfgen der extern verwalteten Kunden.

print STDERR "######### 2nd pass #########\n";

unless (open IMPORT, "<$Import") {
    endout ("/tmp/$progname-dirs.$$");
    close TODB;
    print STDERR "$progname: Failed to open imported users list: $!\n";
    if (system $mkdb, @vxopts, '-d1', $Backup) {
	mailto $ToAdmin,
	    "FATALER FEHLER: Restaurierung der ursprnglichen Mail-DB\n",
	    "nach einer fehlgeschlagenen Eintragung der extern verwalteten\n",
	    "ist ebenfalls fehlgeschlagen!\n";
	die "$progname: FATAL! I couldn't restore the original MailDB!\n";
    } else {
	mailto $ToAdmin,
	    "WARNUNG: Eintragung der extern verwalteten Kunden in die\n",
	    "Mail-DB ist fehlgeschlagen. Die ursprngliche Mail-DB konnte\n",
	    "wiederhergestellt werden.\n";
	die "$progname: original MailDB restored!\n";
    }
}

##for $ix (keys %domains) { print STDERR "$ix => `$domains{$ix}'\n"; }

$current_domain = undef;
#open LOG, ">/tmp/$progname.log";
while (<IMPORT>) {
    if (m(^DOMAIN\s+\"([^\"]+)\"|^NONSTD\s+DOMAIN\s+\"([^\"]+)\")) {
	$current_domain = $1;
	if (exists $domains{$current_domain}) {
	    if ($_ =~ m(LINKTO) and $domains{$current_domain} =~ m(LINKTO)) {
		print TODB $_;
#		print LOG $_;
	    } else {
		print TODB "DOMAIN \"$current_domain\"\n";
#		print LOG "DOMAIN \"$current_domain\"\n";
	    }
	} else {
	    print TODB $_;
#	    print LOG $_;
	}
    } elsif (m(^ADMIN)) {
	unless (exists $domains{$current_domain}) {
	    if (m(^ADMIN \"[^\"]+\" (\"[^\"]+\".*))) {
		print TODB "ADMIN $1\n";
#		print LOG "ADMIN $1\n";
	    } else {
		print TODB $_;
#		print LOG $_;
	    }
	}
    } else {
	print TODB $_;
#	print LOG $_;
    }
}

#close LOG;
close IMPORT;
close TODB;

endout ();
open DIRS, "</tmp/$progname-dirs.$$";
$gconf = "$getconf " . join(' ', @vxopts);
$user = `$gconf vxuser`; chomp $user; $uid = getpwnam ($user);
$group = `$gconf vxgroup`; chomp $group; $gid = getgrnam ($group);
while (<DIRS>) {
    chomp;
    ($dom, $dir) = split / /, $_;
    unless (-d $dir) {
	mkdir "$dir", 0777;
	chown $uid, $gid, "$dir";
	chmod 01777, "$dir";
	print "Created directory for new domain `$dom'.\n";
    }
    if (exists ${$mtbindings}{$dom}) {
	print STDERR "WARNING! Existing mailertable entry for `$dom' not ",
		     "overwritten!\n";
    } else {
	${$mtbindings}{$dom} = "virtual:$dom";
	${$mtbindings}{".$dom"} = "virtual:$dom";
    }
    if (defined $rtbindings) { ${$rtbindings}{$dom} = 'RELAYTO'; }
    if (defined $acbindings) { ${$acbindings}{$dom} = 'RELAY'; }
}
close DIRS;
unlink "/tmp/$progname-dirs.$$";

if (update_dbfiles ('/etc/mail/mailertable_new',1,@{$mthead},%{$mtbindings},\&cmp_mt)) {
    die "$progname: unable to create the new mail routing table: $!\n";
}
if (system 'mv', '/etc/mail/mailertable_new', '/etc/mail/mailertable') {
    die "$progname: unable to overwrite the old mail routing table: $!\n";
}
if (system 'cp', '/etc/mail/mailertable.db', '/etc/mail/mailertable_old.db') {
    die "$progname: unable to backup the old mail routing database: $!\n";
}
if (system 'cp', '/etc/mail/mailertable_new.db', '/etc/mail/mailertable.db') {
    if (system 'cp','/etc/mail/mailertable_old.db','/etc/mail/mailertable.db') {
	die "$progname: FATAL! restoring the old mail routing database ",
	    "failed: $!\n";
    }
    unlink '/etc/mail/mailertable_old.db';
    die "$progname: unable to write a new mail routing database:$!\n";
}
unlink '/etc/mail/mailertable_old.db', '/etc/mail/mailertable_new.db';

if (defined $rthead) {
    if (update_dbfiles ('/etc/mail/RelayTo_new',0,@{$rthead},%{$rtbindings},\&cmp_rt)) {
	die "$progname: unable to create the new relay control table: $!\n";
    }
    if (system 'cp', '/etc/mail/RelayTo', '/etc/mail/RelayTo_old') {
	die "$progname: unable to backup the relay control table:  $!\n";
    }
    if (system 'cp', '/etc/mail/RelayTo_new', '/etc/mail/RelayTo') {
	if (system 'cp', '/etc/mail/RelayTo_old', '/etc/mail/RelayTo') {
	    die "$progname: FATAL! restoring the old relay control table ",
		"failed: $!\n";
	}
	unlink '/etc/mail/RelayTo_old';
	die "$progname: unable to write a new relay control table: $!\n";
    }
    unlink '/etc/mail/RelayTo_old', '/etc/mail/RelayTo_new';
}

if (defined $achead) {
    if (update_dbfiles ('/etc/mail/access_new',1,@{$achead},%{$acbindings},\&cmp_ac)) {
	die "$progname: unable to create the new access control table: $!\n";
    }
    if (system 'mv', '/etc/mail/access_new', '/etc/mail/access') {
	die "$progname: unable to overwrite the access control table: $!\n";
    }
    if (system 'cp', '/etc/mail/access.db', '/etc/mail/access_old.db') {
	die "$progname: unable to backup the old access control database: $!\n";
    }
    if (system 'cp', '/etc/mail/access_new.db', '/etc/mail/access.db') {
	if (system 'cp', '/etc/mail/access_old.db', '/etc/mail/access.db') {
	    die "$progname: FATAL! restoring the old mail routing database ",
		"failed: $!\n";
	}
	unlink '/etc/mail/access_old.db';
	die "$progname: unable to write a new mail routing database:$!\n";
    }
    unlink '/etc/mail/access_old.db', '/etc/mail/access_new.db';
}

if (defined $rthead) { system '/sbin/init.d/sendmail', 'reload'; }

endout ("/tmp/$progname-dirs.$$");
unless (system "gzip", "-9f", $Backup) {
    print STDERR "$progname: compressed backup of MailDB saved under the",
		 "name\n",
		 "$filler  `$Backup.gz'.\n";
} else {
    print STDERR "$progname: uncompressed backup of MailDB saved under the",
		 "name\n",
		 "$filler  `$Backup'.\n";
}

print STDERR "+++ `$progname' successfully terminated +++\n";
exit 0;

sub mydate() {
    my ($d, $m, $y);
    $mydate = time unless (defined $mydate);
    ($d, $m, $y) = (localtime $mydate)[3, 4, 5];
    ($y + 1900, $m + 1, $d)
}

sub mailto($@) {
    my $rcpt = (shift @_);
    unless (open MAIL, "|$mailcmd") {
	print STDERR "$progname: Sending e-mail failed: $!\n";
	return 0;
    }
    print MAIL <<EOT;
From: "MailDB creator" <mail\@blinx.de>
To: $rcpt

EOT
    print MAIL @_;
    close MAIL;
    1
}

sub newout ($) {
    open SAVOUT, ">&STDOUT";
    open STDOUT, ">$_[0]";
}

sub endout (@) {
    open STDOUT, ">&SAVOUT";
    close SAVOUT;
    if (@_) { unlink $_[0]; }
}

# Lies eine der in `/etc/mail' vorkommenden Datenbankdateien ein
# und gib alle Kommentare in einer Liste und alle Zeilen mit Wertepaaren
# als Hash zurck.
#
sub read_dbsource ($) {
    my ($dbsource) = @_;
    my (@head, %bindings, $key, $data);
    unless (open DBSOURCE, "<$dbsource") {
	print STDERR "WARNING! Failed attempt to read `$dbsource': $!\n";
	return ( undef, undef );
    }
    @head = ();
    %bindings = ();
    while (<DBSOURCE>) {
	chomp;
	next if (/^\s*$/);
	if (/^#/) { push @head, $_; next; }
	($key, $data) = split /\s+/, $_;
	$bindings{$key} = $data;
    }
    close MTFILE;
    ( [ @head ], { %bindings } )
}

# Schreibe die angegebenen Daten (Kommentare (als Liste) und Wertepaare als Hash
# in die angegebene Datenbankdatei; erzeuge auch die binre Datenbankdatei auf
# Wunsch neu (2. Argument <> 0).
#
sub update_dbfiles ($$\@\%&) {
    my ($dbsource, $binupdate, $head, $bindings, $cmpfn) = @_;
    my ($dbbinary, $key, $data, $kmaxlen, $klen, $err);
    $err = 0;
    unless (open DBSOURCE, ">$dbsource") {
	print STDERR "WARNING! Failed attempt to write `$dbsource': $!\n";
	$err = 1;
    } else {
	print DBSOURCE (join "\n", @{$head}), "\n";
	$kmaxlen = 0;
	for $key (keys %{$bindings}) {
	    $kmaxlen = length $key if ((length $key) > $kmaxlen);
	}
	$kmaxlen += 8 - ($kmaxlen % 8);# if (($kmaxlen % 8) != 0);
	for $key (sort { &{$cmpfn}($a,$b) } (keys %{$bindings})) {
	    $klen = $kmaxlen - (length $key);
	    $klen += 8 - ($klen % 8) if (($klen % 8) != 0);
	    $klen /= 8;
	    print DBSOURCE $key . ("\t" x $klen) . ${$bindings}{$key} . "\n";
	}
	close DBSOURCE;
    }
    return $err unless ($binupdate);
    unless (open DBBINARY, "| /usr/sbin/makemap hash $dbsource.db") {
	print STDERR "WARNING! Failed attempt to write `$dbsource.db': $!\n";
	$err += 2;
    } else {
	for $key (keys %{$bindings}) {
	    print DBBINARY "$key\t${$bindings}{$key}\n";
	}
	close DBBINARY;
    }
    $err
}

sub cmp_mt ($$) {
    my ($l, $r) = @_;
    unless ($l =~ s/^\.(.+)/$1a/) { $l .= 'b'; }
    unless ($r =~ s/^\.(.+)/$1a/) { $r .= 'b'; }
    $l cmp $r
}

sub cmp_rt ($$) { $_[0] cmp $_[1] }

sub cmp_ac ($$) { $_[0] cmp $_[1] }
