/* emHeader.h
**
** Header file for `emHeader.c'.
** (Data type for handling the header lines of an e-mail.)
**
*/
#ifndef _EMHEADER_H
#define _EMHEADER_H

struct ehList_s;
typedef struct ehList_s *ehList_t;

typedef struct {
    ehList_t l, f;
} emHeader_t;

struct ehList_s { ehList_t next, inext; char *name, *value; };

/* insert a new header element into the emHeader_t structure */
extern int emHeader_ins (emHeader_t *h, char *name, char *value);

/* delete a header element from the emHeader_t structure */
extern int emHeader_del (emHeader_t *h, char *name, int pos);

/* return a header element from the emHeader_t structure */
extern ehList_t emHeader_get (emHeader_t *h, char *name, int pos);

/* replace a header element in the emHeader_t structure */
extern int emHeader_chg (emHeader_t *h, char *name, int pos, char *value);

/* free all headers */
extern void emHeader_free (emHeader_t *h);

#endif /* defined(_EMHEADER_H) */
