/* check.c
**
** existency check
**
*/

#include "vxerror.h"
#include "tools.h"
#include "dbif.h"
#include "mrmacs.h"

int check_entry (DBIF_FILE db, char *entry, int verbose)
{
    dbif_rec *rec;
    char *newname;
    int rt;
    newname = gdupl (__FILE__, __LINE__, entry);
    ifnull (rec = dbif_get (db, newname)) {
	if (verbose) {
	    fprintf (stderr, "`%s' not found!\n", newname);
	}
	return 1;
    }
    rt = dbif_rectype (rec);
    while (rt == RT_LINK || rt == RT_DOMLINK) {
	if (verbose) { printf ("%s -> ", newname); }
	gfree (newname); newname = gdupl (__FILE__, __LINE__, rec->folder);
	dbif_free (rec);
	ifnull (rec = dbif_get (db, newname)) {
	    if (verbose) {
		fprintf (stderr, "`%s' broken link!\n", newname);
		return 1;
	    }
	}
    }
    if (verbose) { printf ("%s\n", newname); }
    return 0;
}
