/* ascanner.h
**
** Interface file for `ascanner.c'
** (scan header elements)
**
*/
#ifndef _ASCANNER_H
#define _ASCANNER_H

struct route_s;

typedef struct route_s *route_t;

struct route_s {
    route_t next;
    char *route;
};

struct addrlist_s;

typedef struct addrlist_s *addrlist_t;

struct addrlist_s {
    addrlist_t next;	/* next item in an address list... */
    char *gphrase;
    char *phrase;	/* personal name (i.e. longname, ...) */
    char *comment;	/* anything in `(' and ')' (concatenated) */
    char *user;		/* user name in mail system (mailbox?) */
    char *domain;	/* domain name in mail system */
    route_t route;	/* source route, e.g. <@h1, @h2, ... : user@host> */
			/*                     =============              */
    char *error;	/* error message text */
};

addrlist_t rfc822_addrlist (char **_p, char *host);
addrlist_t rfc822_address (char **_p, char *host);
addrlist_t rfc822_singleaddr (char **_p, char *host);
char *rfc822_addrstrg (char **_p, char *host);
char *rfc822_addr2strg (addrlist_t addr, int full);
void route_free (route_t rt);
void address_free (addrlist_t al);


#endif /* defined(_ASCANNER_H) */
